#
#  btm_Merge_Points.rb
#  
#
#  Created by •BTM on 12/06/09.	v 1.0
#  Updated on 15/06/09:			v 1.1
#  Updated on 23/06/09:			v 1.2
#
#	NAME: Merge Points
#
#	VERSION 1.2	(23/06/09)
#	~ Added proper undo function, a cursor, toolbar, it now uses the VCB for input, and other small changes were made.
#
#	VERSION: 1.1
#	~ Very small changes.
#
#	USE:	Moves points that are close enough to a position defined by the mouse left click.
#			Good for lowering polycount, or for getting rind of pesky areas with weird lines.
#
#
#
require 'sketchup.rb'
#===================================================================================
class MergePoints
#===================================================================================
@@max_weld_distance = 0.0.to_l
#===================================================================================
	def onSetCursor
	UI.set_cursor(@cursor)
	end
#===================================================================================
	def activate
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	@model = Sketchup.active_model
	@entities = @model.active_entities
	@points = []
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	cursor_path = Sketchup.find_support_file("mergepoints.png", "Plugins/btm_Point_Merger_Tools/")
	@cursor = UI.create_cursor(cursor_path, 12, 12)
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	Sketchup.set_status_text "Moves Points within the specified distance, to where you click.", SB_PROMPT
	Sketchup.set_status_text "Max. Distance", SB_VCB_LABEL
	Sketchup.vcb_value = @@max_weld_distance
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	end
#===================================================================================
	def onUserText(text, view)
	@@max_weld_distance = text.to_l
	Sketchup.vcb_value = @@max_weld_distance
	end
#===================================================================================
	def enableVCB?
	return true
	end
#===================================================================================	
	def onLButtonUp(flags, x, y, view)
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	@start = @model.start_operation "Merge Points"
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	ip1 = view.inputpoint x,y
	pt1 = ip1.position
	@mouse_point = Geom::Point3d.new pt1
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		@entities.each do |e|
			if e.typename == "Edge"
			@points << e.start
			@points << e.end
			end
		end
	@points.uniq!
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		@points.each do |p|
		pos = p.position
		dist = pos.distance @mouse_point
			if dist <= @@max_weld_distance
			vec = p.position.vector_to @mouse_point
			@entities.transform_entities(vec,p)
			end
		end
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	@done = @model.commit_operation "Merge Points"
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	end
#===================================================================================
end
		$point_merger_menu = UI.menu("Plugins").add_submenu("Point Merger")

		$point_merger_toolbar = UI::Toolbar.new "Merge Points"
		mgp = UI::Command.new("Merge Points") { Sketchup.active_model.select_tool MergePoints.new }
		$point_merger_menu.add_item mgp
		mgp.small_icon = "pmerge_16.png"
		mgp.large_icon = "pmerge_24.png"
		mgp.tooltip = "Merge Points"
		toolbar = $point_merger_toolbar.add_item mgp
		case toolbar.get_last_state
		when 1
			toolbar.restore
		when -1   
			toolbar.show
		end