#
#  btm_Merge_Points_to_Selection.rb
#  
#
#  Created by •BTM on 12/06/09.	v 1.0
#  Updated on 15/06/09:			v 1.1
#  Updated on 23/06/09:			v 1.2
#
#	NAME: Merge Points to Lines
#
#	VERSION: 1.2	(23/06/09)
#	~ Added ability to find edges and endpoints of selected faces, a proper 'undo' function, a toolbar, and slight changes.
#
#	VERSION: 1.1
#	~ Added ability to move to endpoints.
#
#	USE:	Moves points that are close enough to the closest point of any selected lines, so that they are on the line.
#			
#
#
#
require 'sketchup.rb'
#===================================================================================
class MergePointsToSelection
#===================================================================================
@@max_weld_distance=0.0.to_l
#===================================================================================
	def activate
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	@model = Sketchup.active_model
	@entities = @model.active_entities
	@selection = @model.selection
	
	@start = @model.start_operation "Merge Points to Lines"
	
	@edges = []
	@points = []
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	prompts = ["Distance", "Move to…"]
	defaults = [ @@max_weld_distance, "closest endpoint"]
	list = ["", "closest endpoint|closest line"]
	@results = UI.inputbox prompts, defaults, list, "Merge Points to Lines"
	@@max_weld_distance= @results[0]
		if @results[1] == "closest line"
		@move_to = 1
		elsif @results[1] == "closest endpoint"
		@move_to = 2
		end
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		@entities.each do |e|
			if e.typename == "Edge" and @selection.contains? e
			@edges << e
			elsif e.typename == "Face" and @selection.contains? e
				e.edges.each do |c|
				@edges << c
				end
			end
		end
	@edges.uniq!
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		@entities.each do |p|
			if p.typename == "Edge"
			@points << p.start
			@points << p.end
			end
		end
	@points.uniq!
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		@points.each do |t|
		pos = t.position
		@close_dist = @@max_weld_distance
		@close_point = t.position
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
			@edges.each do |l|

			l_line = [l.start.position, l.end.position]
			l_start = l.start.position
			l_end = l.end.position
			linepos1 = pos.project_to_line l_line
			length_s = l_start.distance linepos1
			length_e = l_end.distance linepos1
			length_edge = l_start.distance l_end

				if @move_to == 1
					if length_s > length_edge and length_e
					@linepos = l_end
					elsif length_e > length_edge and length_s
					@linepos = l_start
					else @linepos = linepos1
					end
				elsif @move_to == 2
					if length_s < length_e
					@linepos = l_start
					elsif length_s > length_e
					@linepos = l_end
					end
				end

			dist = pos.distance @linepos
				if dist <= @close_dist
				@close_point = @linepos
				@close_dist = dist
				end
			end
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
		vec = t.position.vector_to @close_point
		@entities.transform_entities(vec,t)
		end
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	@done = @model.commit_operation "Merge Points to Lines"
	end
#===================================================================================
end


		mps = UI::Command.new("Merge Points to Selection") { Sketchup.active_model.select_tool MergePointsToSelection.new }
		$point_merger_menu.add_item mps
		mps.small_icon = "ptl_16.png"
		mps.large_icon = "ptl_24.png"
		mps.tooltip = "Merge Points to Selection"
		toolbar = $point_merger_toolbar.add_item mps
		case toolbar.get_last_state
		when 1
			toolbar.restore
		when -1   
			toolbar.show
		end